/*
///////////////////////////////////////////////////////////////////////////////////
       Version : WabModCheap 2.2
        Author : AloneTrio from WAB
          Date : 13/03/2007  12:30
       WebSite : http://www.wab.com     (in the wii section)
///////////////////////////////////////////////////////////////////////////////////
*/


#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include "lptport.h"
#include "cn302.h"

int RW_WAIT = 100;
int C_WAIT = 1000;


int main(int argc, char* argv[])
{
uint8_t *monbuf;
uint8_t *monbuf2;
int tst=0;

monbuf = (char *)malloc(0x21);
monbuf2 = (char *)malloc(0x0C);

char wiimodel[0];
int  wii_memlocs;
int  wii_mediaflag;
int  wii_emuflag;
int  wii_di;
uint8_t wiiunlockcmd[4]={0x41,0x00,0x00,0x00};
uint8_t inquiry[0];

printf("            ۲      ۲   ۲ \n");
printf("            ۲     ۲    ۲  \n");
printf("                          \n");
printf("                        \n");
printf("                      \n");
printf("                        \n");
printf("                      \n");
printf("                      \n");
printf("Ŀ\n");
printf("                    - W e  A r e  B a c k -                  \n"); 
printf("Ĵ\n");
printf("       .. : : WabModCheap 2.2 -> Interactiv Sync : : ..      \n");
printf("                                                             \n");
printf("+ Compatible DMS/D2A/D2B + Wii original + Wii Backup Native +\n");
printf("          + GC original + GC backup + GC HomeBrew +          \n");
printf("                                                             \n");
printf("soon : Max drive speed - OnTheFly Region Patching            \n");
printf("\n");


        if((argc <= 2) || (argc >3)){
		printf("Usage : %s RW_WAIT C_WAIT\n",argv[0]);
		printf("( example -> %s 100 1000 )\n",argv[0]);
		printf("you can try 100,200,300,500, ... for the C_WAIT value.\n\n");
		return(-1);
	}

	RW_WAIT = (int)strtol(argv[1],NULL,0);
	C_WAIT =  (int)strtol(argv[2],NULL,0);;
	
	printf("[+] RW_WAIT = %s\n[+] C_WAIT = %s\n",argv[1],argv[2]);

	if(lptport_init()==-1)
	{
		printf("[!] Could not open parallel port driver\n\n");
	        return(-1);
	}
	atexit((void*)lptport_close);
	
	if (cn302_init(RW_WAIT,C_WAIT,C_WAIT) == -1){
		printf("[!] Sync failed! Please check your connections.\n\n");
		lptport_close();
	        return(-1);
	}
	atexit((void*)cn302_close);
	

// WII MODEL DETECTION -------------------------------------------------------------
	cn302_peek_byte(0x40BCB2, wiimodel);
	printf("[+] WII Model Detection : ");
        if(wiimodel[0]!=0x20){
	   printf("DMS/D2A\n");
	   wii_memlocs = 0x82b6;
	   wii_mediaflag = 0x8576;
	   wii_emuflag = 0x8598;
	   wii_di = 0x8308;
	}
	else{
	   printf("D2B\n");
   	   wii_memlocs = 0x82be;
  	   wii_mediaflag = 0x8580;
   	   wii_emuflag = 0x85A2;
   	   wii_di = 0x8312;
	} 

// UNLOCK WII MEM ------------------------------------------------------------------        
        cn302_write_block(wii_memlocs,0x4,wiiunlockcmd);	
	printf("[+] WII Memory Unlocked\n");

// WAIT FOR DISK INSERTED ---------------------------------------------------------
	printf("\nPlease Insert a Disk...\n\n");
	while(inquiry[0] != 0xD0){
		cn302_peek_byte(0x40BA06, inquiry);
	}	
	printf("[+] Disk Inserted\n");

// PATCHING W00T !! --------------------------------------------------------------
    	cn302_peek_byte(wii_mediaflag, inquiry);
	if((inquiry[0] & 0x10) == 0x10){
		printf("[+] Patching ...\n");
	        cn302_write_block(wii_memlocs,0x4,wiiunlockcmd);	
		cn302_poke_byte(wii_emuflag,0x04);
		cn302_poke_byte(wii_mediaflag,0x28);
		inquiry[0]=0;
		while(inquiry[0] != 0xF1){
                	cn302_peek_byte(0x40BA06, inquiry);
        	}
		cn302_poke_byte(wii_mediaflag,0x38);
	}        
// READING GAME NAME -------------------------------------------------------------
        printf("[+] Retrieving Game Name (experimental) : ");
	while ( tst < 250 ){
		cn302_read_block(wii_di, 0x0C, monbuf2);
		if ((monbuf2[4] == 0x00) && (monbuf2[5] == 0x08) && (monbuf2[6] == 0x00) && (monbuf2[7] == 0x00)) {
			cn302_read_block(0x4001A0, 0x21, monbuf);
		}
		tst++;
	}
	printf("\"%s\"\n\n",monbuf);

	printf("Giga Ultra Stealth Mode : We do not stay connected to wii anymore... ;)  \n");
	printf("Thanks for using this WAB Production. \n\n");
	return(1);
}
